com.unitech.lib.params

## Class EngineParam

- java.lang.Object
- - com.unitech.lib.params.BaseParam
  - - com.unitech.lib.params.EngineParam

-     public class EngineParam
      extends BaseParam

  The EngineParam class represents a parameter for the engine.

- - ### Field Summary

    - ### Fields inherited from class com.unitech.lib.params.BaseParam

      `_default, _max, _maxVersion, _min, _minVersion, _options, _value, type`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EngineParam(EngineParamID id)` Initializes a new instance of the EngineParam class.
    `EngineParam(EngineParamID id, boolean defaultValue)` Initializes a new instance of the EngineParam class.
    `EngineParam(EngineParamID id, int defaultValue, int minValue, int maxValue)` Initializes a new instance of the EngineParam class.
    `EngineParam(EngineParamID id, String defaultValue)` Initializes a new instance of the EngineParam class.
    `EngineParam(EngineParamID id, String defaultValue, ArrayList<String> options)` Initializes a new instance of the EngineParam class.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getDefaultValue()` Get the default value of the parameter.
    `EngineParamID` | `getId()` Gets the ID of the parameter.
    `int` | `getMaxValue()` Get the maximum value of the parameter.
    `int` | `getMinValue()` Get the minimum value of the parameter.
    `ArrayList<String>` | `getOptions()` Get a list of options for the parameter.
    `String` | `getValue()` Gets the value of the parameter.
    `void` | `setValue(String value)` Sets the value of the parameter.
    `EngineParam` | `toEngineParam()` In child classes, this method is override to return an EngineParam.

    - ### Methods inherited from class com.unitech.lib.params.BaseParam

      `getMaxVersion, getMinVersion, toDeviceParam`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EngineParam

          public EngineParam(EngineParamID id)

      Initializes a new instance of the EngineParam class.
      Parameters:
        `id` - The ID of the parameter.

    - #### EngineParam

          public EngineParam(EngineParamID id,
                             String defaultValue)

      Initializes a new instance of the EngineParam class.
      Parameters:
        `id` - The ID of the parameter.
        `defaultValue` - The default value of the parameter.

    - #### EngineParam

          public EngineParam(EngineParamID id,
                             String defaultValue,
                             ArrayList<String> options)

      Initializes a new instance of the EngineParam class.
      Parameters:
        `id` - The ID of the parameter.
        `defaultValue` - The default value of the parameter.
        `options` - The options for the parameter.

    - #### EngineParam

          public EngineParam(EngineParamID id,
                             boolean defaultValue)

      Initializes a new instance of the EngineParam class.
      Parameters:
        `id` - The ID of the parameter.
        `defaultValue` - The default value of the parameter.

    - #### EngineParam

          public EngineParam(EngineParamID id,
                             int defaultValue,
                             int minValue,
                             int maxValue)

      Initializes a new instance of the EngineParam class.
      Parameters:
        `id` - The ID of the parameter.
        `defaultValue` - The default value of the parameter.
        `minValue` - The minimum value of the parameter.
        `maxValue` - The maximum value of the parameter.

  - ### Method Detail

    - #### toEngineParam

          public EngineParam toEngineParam()

      Description copied from class: `BaseParam`
      In child classes, this method is override to return an EngineParam.
      Overrides:
        `toEngineParam` in class `BaseParam`
      Returns:
        An EngineParam object representing the current BaseParam.

    - #### getId

          public EngineParamID getId()

      Gets the ID of the parameter.
      Returns:
        The ID of the parameter.

    - #### getValue

          public String getValue()

      Gets the value of the parameter.
      Returns:
        The value of the parameter.

    - #### setValue

          public void setValue(String value)

      Sets the value of the parameter.
      Parameters:
        `value` - The value to set.

    - #### getDefaultValue

          public String getDefaultValue()

      Get the default value of the parameter.
      Returns:
        The default value of the parameter.

    - #### getOptions

          public ArrayList<String> getOptions()

      Get a list of options for the parameter.
      Returns:
        A list of options for the parameter.

    - #### getMinValue

          public int getMinValue()

      Get the minimum value of the parameter.
      Returns:
        The minimum value of the parameter.

    - #### getMaxValue

          public int getMaxValue()

      Get the maximum value of the parameter.
      Returns:
        The maximum value of the parameter.